VARLST 	;VARIABLE NAME LISTER - (VARLST)
 	;BY BOB KOEHLER
 	;R.D. #4, BOX 174, LAKE WALTON ROAD
 	;HOPEWELL JUNCTION, NEW YORK 12533
 	;RELEASED TO THE PUBLIC DOMAIN 12/23/85
 NAME	EQU	418EH		;ADDR. OF 'NAME' VECTOR
 	ORG	57951	;MAY BE RE-ASSEMBLED ANYWHERE
 SETUP	LD	HL,(NAME+1)	;GET ORIG. ADDRESS
 	LD	(ORIG+1),HL	;SAVE IT
 	LD	HL,START	;GET NEW ADDRESS
 	LD	(NAME+1),HL	;SUBST. NEW FOR ORIG.
 	JP	BACK		;GO TO BASIC 'READY'
 START	PUSH	AF		;SAVE STATUS FLAGS
 	LD	A,(HL)		;GET VALUE
 	CP	'!'		;THIS ROUTINE?
 	JR	Z,NOW		;YES
 	POP	AF		;ELSE RECOVER STATUS
 ORIG	JP	$-$		;GO TO ORIG. ROUTINE
 NOW	LD	HL,ARBUF	;SET BUFFER BOUNDARIES
 	DEC	HL
 	LD	(AREND),HL
 	LD	HL,SNBUF
 	DEC	HL
 	LD	(SNEND),HL
 	LD	BC,500		;EMPTY BUFFERS
 	LD	HL,ARBUF
 LOOP	LD	D,20H
 	LD	(HL),D
 	INC	HL
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,LOOP
 	CALL	LINBEG		;ZERO CHAR. COUNTER
 	LD	HL,(40A4H)	;START ADDR OF BASIC PROG
 	DEC	HL
 SRCH	INC	HL
 	CALL	CRCT		;INCREMENT CHAR. COUNTER
 	LD	A,(HL)		;GET CHARACTER
 	CP	89H		;INPUT?
 	JR	Z,READ
 	CP	8BH		;READ?
 	JR	Z,READ
 	CP	88H		;DATA?
 	JP	Z,DATA
 	CP	22H		;QUOTATION MARK?
 	CALL	Z,QUOTE		;SKIP ANYTHING IN QUOTES
 	CP	0D5H		;EQUALS SIGN?
 	JP	Z,EQUAL		;GET THE NAME
 	CP	0		;LOOK FOR END
 	JR	Z,END		;END OF LINE OR PROGRAM?
 	JR	SRCH		;KEEP GOING
 END	INC	HL
 	INC	HL
 	INC	HL		;END OF PROG. ADDR.?
 	PUSH	HL		;SAVE ADDRESS
 	EX	DE,HL		;NOW IN DE
 	LD	HL,(40F9H)	;E.O.P. ADDRESS HERE
 	SCF
 	CCF			;ZERO CARRY FLAG
 	SBC	HL,DE
 	POP	HL
 	JP	Z,PRINT		;END OF PROGRAM
 	CALL	LINBEG		;ZERO CHAR. COUNTER
 	INC	HL		;SKIP LINE #'S
 	JR	SRCH		;END OF LINE - CONTINUE
 QUOTE	INC	HL
 	CALL	CRCT
 	LD	A,(HL)
 	CP	22H		;LOOK FOR CLOSE QUOTE
 	RET	Z		;FOUND IT
 	JR	QUOTE		;KEEP LOOKING
 READ	INC	HL
 	LD	A,(HL)		;NEXT CHARACTER
 	CP	20H		;SPACE?
 	JR	Z,READ		;SKIP IT
 	CP	22H		;QUOTATION MARK?
 	JR	NZ,CONTIN	;NO
 	CALL	QUOTE		;SKIP ANYTHING IN QUOTES
 NXT	INC	HL		;NEXT CHARACTER
 	LD	A,(HL)
 	CP	3BH		;SEMICOLON?
 	JR	Z,NXT		;SKIP IT
 	CP	20H		;SPACE?
 	JR	Z,NXT		;SKIP IT
 CONTIN	PUSH	HL		;SAVE 1ST CHAR. ADDRESS
 	LD	BC,0		;SET CHAR. CT. & VAR TYPE
 GETNM	LD	A,(HL)
 	CP	2CH		;COMMA?
 	JR	Z,SAVE		;END OF NAME
 	CP	3AH		;COLON?
 	JR	Z,SAVE
 	CP	0
 	JR	Z,SAVE		;END OF LINE
 	CP	28H		;OPEN PARENTHESIS?
 	JR	Z,ARYNM		;IT'S AN ARRAY
 	INC	B		;PART OF NAME
 	INC	HL
 	JR	GETNM		;GET NEXT CHARACTER
 ARYNM	LD	C,1
 SAVE	POP	HL
 	DEC	HL
 	PUSH	HL		;SAVE AGAIN
 	CALL	CLRBF		;STORE IF NOT DUPLICATE
 	POP	HL
 LOOP7	INC	HL
 	LD	A,(HL)
 	CP	20H		;SPACE?
 	JR	Z,LOOP7		;SKIP IT
 	CP	2CH		;COMMA?
 	JR	Z,COMMA		;GET NEXT NAME
 	CP	3AH		;COLON?
 	JP	Z,SRCH		;CONTINUE SEARCH
 	CP	0		;END OF LINE?
 	JR	Z,END		;END OF PROGRAM?
 	JR	LOOP7		;KEEP LOOKING
 COMMA	INC	HL		;SKIP COMMA
 	JR	CONTIN		;GET NEXT NAME
 DATA	INC	HL		;SKIP OVER ALL DATA LINES
 	LD	A,(HL)
 	CP	0
 	JR	Z,END		;END OF LINE
 	CP	22H		;QUOTE?
 	CALL	Z,QUOTE		;SKIP ANYTHING IN QUOTES
 	JR	DATA		;KEEP LOOKING
 EQUAL	PUSH	HL		;SAVE ADDRESS
 	LD	BC,0		;B COUNTS CHAR'S IN NAME,
 	DEC	HL		;   C HOLDS VARIABLE TYPE
 	LD	A,(HL)
 	CP	29H		;CLOSE PARENTHESIS?
 	JR	NZ,NAME1	;NOT AN ARRAY
 	CALL	DECCT		;DECREMENT CHAR. CNTR.
 	LD	C,1		;IT IS AN ARRAY
 LOOP1	DEC	HL
 	CALL	DECCT		;DECREMENT CHAR. CNTR.
 	LD	A,(HL)
 	CP	28H		;OPEN PARENTHESIS?
 	JR	NZ,LOOP1	;NOT YET
 NAME2	DEC	HL		;TEST THE CHARACTER
 NAME1	CALL	DECCT		;DECREMENT CHAR. CNTR.
 	LD	A,(NUMCH)	;TEST FOR BEG. OF LINE
 	CP	0
 	JR	Z,BEGIN
 	LD	A,(HL)
 	CP	20H		;SPACE?
 	JR	Z,BEGIN		;END OF NAME
 	CP	3AH		;COLON?
 	JR	Z,BEGIN		;END OF NAME
 	CP	5BH		;END OF ALPHABET
 	JR	NC,BEGIN	;OUT OF RANGE
 	INC	B
 	JR	NAME2
 BEGIN	CALL	CLRBF
 	POP	HL
 	JP	SRCH
 CLRBF	INC	HL		;IS NAME VALID?
 	LD	A,(HL)
 	CP	41H		;MUST BE ALPHA. CHAR.
 	RET	C		;NO - TOO LOW
 	CP	5BH
 	RET	NC		;NO - TOO HIGH
 	DEC	HL
 	LD	A,20H		;CLEAR BUFFER
 	LD	(NMBUF),A
 	LD	(NMBUF+1),A
 	LD	(NMBUF+2),A
 	LD	A,0
 	LD	(NBPOS),A
 	LD	(NBPOS+1),A
 LOOP2	INC	HL
 	LD	A,(HL)
 	PUSH	HL
 	LD	DE,NMBUF	;BEGINNING OF BUFFER
 	LD	HL,(NBPOS)
 	ADD	HL,DE		;GET CHAR. POSITION
 	LD	(HL),A		;STORE CHARACTER
 	LD	HL,(NBPOS)
 	INC	HL
 	LD	(NBPOS),HL
 	POP	HL
 	DJNZ	LOOP2
 	LD	A,1		;TEST FOR TYPE
 	CP	C
 	JR	Z,ARRAY		;IT'S AN ARRAY
 	LD	HL,(SNEND)
 	LD	DE,SNBUF
 	EX	DE,HL
 	JR	GO
 ARRAY	LD	HL,(AREND)
 	LD	DE,ARBUF
 	EX	DE,HL
 GO	PUSH	BC
 	PUSH	HL
 	PUSH	DE
 	LD	IX,NMBUF
 	LD	B,3
 	SBC	HL,DE
 	JR	C,LOCATE	;BUFFER NOT EMPTY
 	POP	DE
 	POP	HL
 	LD	(WRDST),HL
 	EX	DE,HL
 	JR	FIRST		;ENTER NAME
 LOCATE	POP	DE		;LISTING END
 	POP	HL
 LOOP4	LD	(WRDST),HL
 	LD	A,20H
 	CP	(HL)
 	JR	Z,STORE		;END OF LIST
 LOOP3	LD	A,(IX)
 	CP	(HL)
 	JR	Z,NXTCHR	;CHARACTERS MATCH
 	JR	C,STORE		;PUT NEW NAME NEXT
 	LD	A,20H		;END OF STORED NAME?
 	CP	(HL)
 	JR	Z,NXTNM		;YES
 LOOP5	LD	HL,(WRDST)
 	LD	IX,NMBUF
 	LD	B,3
 	INC	HL	 	;GO FARTHER
 	INC	HL
 	INC	HL
 	INC	HL
 	JR	LOOP4
 NXTCHR	DEC	B
 	JR	Z,DUPL		;DUPLICATE NAME
 	INC	HL
 	INC	IX
 	JR	LOOP3
 DUPL	POP	BC
 	RET			;SEARCH FOR NEXT ONE
 NXTNM	LD	HL,(WRDST)
 	LD	B,3
 	LD	IX,NMBUF
 	JR	LOOP5
 STORE	PUSH	DE		;SAVE END ADDRESS
 	SCF			;SET CARRY FLAG
 	CCF			;ZERO IT
 	LD	HL,(WRDST)	;START. ADDR. OF NEW WRD.
 	EX	DE,HL		;START IN DE, END IN HL
 	SBC	HL,DE
 	INC	HL		;# OF BYTES TO MOVE
 	LD	A,H
 	OR	L
 	JR	Z,CONT		;SKIP IF END OF LIST
 	PUSH	HL		;HOLD IT
 	POP	BC		;NOW IN BC
 	POP	HL		;END ADDRESS
 	PUSH	HL		;SAVE AGAIN
 	LD	DE,4
 	ADD	HL,DE		;NEW END IN HL
 	EX	DE,HL		;NOW IN DE
 	POP	HL		;OLD END IN HL
 	PUSH	HL		;SAVE AGAIN
 	LDDR			;MAKE ROOM FOR NEW NAME
 CONT	POP	HL		;OLD LIST END
 FIRST	LD	BC,4
 	ADD	HL,BC
 	EX	DE,HL		;NEW LIST END IN DE
 	LD	HL,(WRDST)
 	LD	IX,NMBUF
 	LD	B,3
 LOOP6	LD	A,(IX)		;PUT NEW NAME IN TABLE
 	LD	(HL),A
 	INC	IX
 	INC	HL
 	DJNZ	LOOP6
 	POP	BC		;GET VARIABLE TYPE
 	EX	DE,HL
 	LD	A,1
 	CP	C
 	JR	Z,ARYEND	;IT'S AN ARRAY
 	LD	(SNEND),HL	;PUT IN NEW END
 	JR	RTN
 ARYEND	LD	(AREND),HL
 RTN	EX	DE,HL
 	RET
 PRINT	CALL	1C9H		;CLS
 	LD	HL,ARMSG	;ARRAY HEADING
 	CALL	2B75H		;PRINT HEADING
 	LD	A,0DH
 	CALL	33H		;LINE FEED
 	CALL	33H
 	LD	HL,(AREND)	;END OF ARRAY LIST
 	LD	DE,ARBUF	;BEGINNING
 	SBC	HL,DE
 	INC	HL		;# OF BYTES IN LIST
 	LD	A,H
 	CP	L
 	JR	Z,FEED		;NO ARRAYS
 	PUSH	HL
 	POP	BC		;NOW HERE
 	LD	HL,(16416)	;CURSOR LOCATION
 	EX	DE,HL
 	LDIR			;MOVE LIST TO SCREEN
 FEED	LD	A,0DH
 	CALL	33H		;3 LINE FEEDS
 	CALL	33H
 	CALL	33H
 	LD	HL,SNMSG	;VARIABLE NAMES HEADING
 	CALL	2B75H		;PRINT HEADING
 	LD	A,0DH
 	CALL	33H		;2 LINE FEEDS
 	CALL	33H
 	LD	HL,(SNEND)
 	LD	DE,SNBUF
 	SBC	HL,DE
 	INC	HL
 	PUSH	HL
 	POP	BC
 	PUSH 	BC		;SAVE IT AGAIN
 	LD	DE,SNBUF
 	LD	HL,(16416)	;CURSOR LOCATION
 	PUSH	HL		;SAVE CURSOR LOCATION
 	EX	DE,HL
 	LDIR			;MOVE LIST TO SCREEN
 	POP	HL		;ORIG. CURSOR LOCATION
 	POP	BC		;# OF BYTES IN LIST
 	ADD	HL,BC		;END OF LIST
 	LD	(16416),HL	;RELOCATE CURSOR AT END
 	LD	A,0DH
 	CALL	33H		;LINE FEED
 	POP	DE		;RESTORE STACK
 BACK	LD	BC,1A18H
 	JP	19AEH		;BACK TO BASIC READY
 LINBEG	EX	AF,AF'
 	XOR	A
 	EX	AF,AF'
 	RET
 CRCT	EX	AF,AF'
 	INC	A
 	LD	(NUMCH),A
 	EX	AF,AF'
 	RET
 DECCT	EX	AF,AF'
 	DEC	A
 	LD	(NUMCH),A
 	EX	AF,AF'
 	RET
 ARMSG	DEFM	'LIST OF ARRAY VARIABLES:'
 	DEFB	0
 SNMSG	DEFM	'LIST OF SINGLE VARIABLES:'
 	DEFB	0
 ARBUF	DEFS	100
 SNBUF	DEFS	400
 NMBUF	DEFS	3
 NBPOS	DEFS	2
 AREND	DEFS	2
 SNEND	DEFS	2
 WRDST	DEFS	2
 NUMCH	DEFS	1
 	END	SETUP
